/***********************************************************************
*
* Contributed by Abir Majumdar at Macrovision.
* 
* Choose Install Drive - The default Choose Install Folder panel doesn't
* provide an option to choose what drive to install on. This custom code
* provides that option.
*
*
***********************************************************************/

package com.zerog.ia.customcode.panels;

import com.zerog.ia.api.pub.*;
import java.awt.*;
import java.io.File;
import java.io.PrintStream;
import java.util.Vector;
import javax.swing.JComboBox;
import javax.swing.JLabel;

public class ChooseInstallDrive extends CustomCodePanel
{

    public ChooseInstallDrive()
    {
        isSetup = false;
    }

    public boolean setupUI(CustomCodePanelProxy proxy)
    {
        System.out.println("Choose Install Drive...");
        if(isSetup)
            removeAll();
        ccpp = proxy;
        gui = (GUIAccess)proxy.getService(com.zerog.ia.api.pub.GUIAccess.class);
        f = gui.getFrame();
        label_1 = "Choose Install Drive:";
        GridBagLayout gb = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        setLayout(gb);
        jtext_1 = new JLabel(text, 0);
        jtext_1.setFont(new Font(f.getFont().getName(), 1, f.getFont().getSize()));
        jtext_1.setForeground(f.getForeground());
        c.fill = 1;
        c.weightx = 0.0D;
        c.gridx = 0;
        c.gridy = 0;
        c.gridheight = 5;
        c.gridwidth = 2;
        c.insets = new Insets(20, 0, 30, 0);
        c.anchor = 17;
        gb.setConstraints(jtext_1, c);
        add(jtext_1);
        jlabel1 = new JLabel(label_1);
        jlabel1.setFont(f.getFont());
        jlabel1.setForeground(f.getForeground());
        c.weightx = 0.0D;
        c.gridx = 0;
        c.gridy = 6;
        c.gridheight = 1;
        c.gridwidth = -1;
        c.insets = new Insets(20, 5, 0, 10);
        gb.setConstraints(jlabel1, c);
        add(jlabel1);
        jcb = new JComboBox(getDrives());
        c.gridx = 1;
        c.gridy = 6;
        c.gridheight = 1;
        c.gridwidth = 0;
        c.insets = new Insets(20, 10, 0, 5);
        gb.setConstraints(jcb, c);
        add(jcb);
        System.out.println("layout: " + gb.toString());
        isSetup = true;
        return true;
    }

    public void panelIsDisplayed()
    {
    }

    public boolean okToContinue()
    {
        ccpp.setVariable((String)ccpp.getVariable("SELECTED_DRIVE_VARIABLE"), jcb.getSelectedItem());
        return true;
    }

    public String getTitle()
    {
        return "Choose Install Drive";
    }

    private String[] getDrives()
    {
        System.out.println("Before Getting Roots");
        File roots[] = File.listRoots();
        System.out.println("After Getting Roots");
        Vector rootDrivesVector = new Vector();
        for(int i = 0; i < roots.length; i++)
        {
            System.out.println("Drive: \"" + roots[i].getAbsolutePath() + "\"");
            if(!roots[i].getAbsolutePath().trim().equalsIgnoreCase("A:\\") && roots[i].canWrite())
                rootDrivesVector.add(roots[i].getAbsolutePath());
        }

        String rootDrives[] = new String[rootDrivesVector.size()];
        rootDrivesVector.copyInto(rootDrives);
        return rootDrives;
    }

    private JLabel jtext_1;
    private JLabel jlabel1;
    private JComboBox jcb;
    private String label_1;
    private String text;
    private boolean isSetup;
    GUIAccess gui;
    Frame f;
    CustomCodePanelProxy ccpp;
    static Class class$0; /* synthetic field */
}
